com.datecs.crypto

## Enum DUKPT.KeyUsage

- java.lang.Object
- - java.lang.Enum<DUKPT.KeyUsage>
  - - com.datecs.crypto.DUKPT.KeyUsage

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Comparable<DUKPT.KeyUsage>
  Enclosing class:
    DUKPT

      public static enum DUKPT.KeyUsage
      extends java.lang.Enum<DUKPT.KeyUsage>

  KeyUsage defines the possible key usages that can be derived.

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `DataEncryptionBothWays`
    `DataEncryptionDecrypt`
    `DataEncryptionEncrypt`
    `KeyDerivation`
    `KeyDerivationInitialKey`
    `KeyEncryptionKey`
    `MessageAuthenticationBothWays`
    `MessageAuthenticationGeneration`
    `MessageAuthenticationVerification`
    `PINEncryption`

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static DUKPT.KeyUsage` | `valueOf(java.lang.String name)` Returns the enum constant of this type with the specified name.
    `static DUKPT.KeyUsage[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### KeyEncryptionKey

          public static final DUKPT.KeyUsage KeyEncryptionKey

    - #### PINEncryption

          public static final DUKPT.KeyUsage PINEncryption

    - #### MessageAuthenticationGeneration

          public static final DUKPT.KeyUsage MessageAuthenticationGeneration

    - #### MessageAuthenticationVerification

          public static final DUKPT.KeyUsage MessageAuthenticationVerification

    - #### MessageAuthenticationBothWays

          public static final DUKPT.KeyUsage MessageAuthenticationBothWays

    - #### DataEncryptionEncrypt

          public static final DUKPT.KeyUsage DataEncryptionEncrypt

    - #### DataEncryptionDecrypt

          public static final DUKPT.KeyUsage DataEncryptionDecrypt

    - #### DataEncryptionBothWays

          public static final DUKPT.KeyUsage DataEncryptionBothWays

    - #### KeyDerivation

          public static final DUKPT.KeyUsage KeyDerivation

    - #### KeyDerivationInitialKey

          public static final DUKPT.KeyUsage KeyDerivationInitialKey

  - ### Method Detail

    - #### values

          public static DUKPT.KeyUsage[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (DUKPT.KeyUsage c : DUKPT.KeyUsage.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static DUKPT.KeyUsage valueOf(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null